"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var BaseReducer_1 = require("../core/reducer/BaseReducer");
var immer_1 = require("immer");
var StateReturnRequiredError_1 = require("../core/exceptions/StateReturnRequiredError");
var BaseReducer = /** @class */ (function (_super) {
    tslib_1.__extends(BaseReducer, _super);
    function BaseReducer(init, instanceName) {
        return _super.call(this, init, instanceName) || this;
    }
    BaseReducer.prototype.changeState = function (effect, state, action) {
        var newState = effect(state, action);
        if (newState === undefined) {
            if (!immer_1.isDraftable(state)) {
                throw new StateReturnRequiredError_1.StateReturnRequiredError(action.type);
            }
            return state;
        }
        return newState;
    };
    return BaseReducer;
}(BaseReducer_1.BaseReducer));
exports.BaseReducer = BaseReducer;
