"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var vue_1 = tslib_1.__importDefault(require("vue"));
var createReduxStore_1 = require("../core/utils/createReduxStore");
exports.createReduxStore = function (config) {
    var store = createReduxStore_1.createReduxStore(config);
    var originalGetState = store.getState;
    var currentState = originalGetState();
    var resetObserver = function () {
        // Add observer to redux store
        vue_1.default.observable(currentState);
        // Get data from original state until new state have been observed
        store.getState = function () { return currentState; };
    };
    resetObserver();
    store.subscribe(function () {
        var nextState = originalGetState();
        if (nextState !== currentState) {
            currentState = nextState;
            resetObserver();
        }
    });
    return store;
};
